#pragma once
#include "Summation.h"

// The information pertaining to a particle. The dynamic data is stored in a SumData.
class Particle : public Summation
{
public:
	// Properties
	float mass;
	Vector3f x0;
	float perRegionMass;		// The amount of mass that goes to each region = mass * (1.0 / numParentRegions)

	// Dynamic values
	Vector3f x, v, f;
	Vector3f g;
	Matrix3x3f R;				// The rotational component of the transformations of its parent regions -- useful in rendering

	// Relations
	std::vector<LatticeLocation *> parentRegions;

	// Collision stuff
	Particle *nextParticleInCollisionCell;	// Used in maintaining a linked list of particles in the collision cell
};
