#pragma once
#include "Summation.h"

// Just as with Particle, it only holds the info - the dynamic properties are in a SumData
class Region : public Summation
{
public:
	// Precomputed properties
	Vector3f Ex0;
	Vector3f c0;
	float M;

	// Dynamic properties
	Vector3f c;
	Matrix3x3f A;
	Matrix3x3f eigenVectors;	// Cached to warm-start Jacobi iterations for polar decomposition - see Extensions section of FastLSM paper
	// Tr is decomposed into the rotation and translation parts
	Vector3f t;
	Matrix3x3f R;
};
