#pragma once
#include "Vector3f.h"
#include "Matrix3x3f.h"
#include <xmmintrin.h>

// The actual elements of data that must be summmed. These elements will be
//  used to store different things - v will be mixi
//  during the shape matching, and (cr - Rrcr) during goal position calculation;
//  M will be EpmiT during shape matching but Rr
//  during goal position calculation.
__declspec(align(16)) struct SumData
{
public:
	union {
		// Floats
		struct {
			__declspec(align(16)) Vector3f v;
			__declspec(align(16)) Matrix3x3f M;
		};
		struct {
			__m128 m1, m2, m3;
		};
	};
};
