#include "stdafx.h"
#include <limits.h>
#include <functional>
#include <float.h>
#include <assert.h>
#include <stdlib.h>
#include "FastLSM.h"
#include <queue>
#include "jacobi.h"
#include <assert.h>
#include <stdlib.h>

void Body::CalculateInvariants()
{
	printf("Calculating invariants...");

	// Calculate perRegionMass
	for each(Particle *particle in particles)
	{
		particle->perRegionMass = particle->mass / particle->parentRegions.size();
	}

	// Calculate region properties
	// Use fast summation
	for each(Particle *p in particles)
	{
		p->sumData.M.m00 = p->perRegionMass;
		p->sumData.v = p->perRegionMass * p->x0;
	}
	SumParticlesToRegions();
	for each(Region *r in regions)
	{
		r->M = r->sumData.M.m00;
		r->Ex0 = r->sumData.v;
		r->c0 = r->Ex0 / r->M;
	}

	printf(" done.\n");
}

LatticeLocation* Body::GetLatticeLocation(Point3 index)
{
	std::map<Point3, LatticeLocation*>::iterator found = lattice.find(index);
	if(found == lattice.end()) return NULL;
	else return found->second;
}
